from torchvision.models import mobilenet_v2
from torch import nn


def core50_mobilenetv2(num_classes=50, pretrained=True):
    model = mobilenet_v2(pretrained=pretrained)
    # switch head to correct number of classes
    model.classifier = nn.Sequential(
        nn.Dropout(0.2),
        nn.Linear(model.last_channel, num_classes),
    )
    return model
