import logging

import random

import datetime
import sys
import os
import ray

from dac.utils import maybe_set_gpus

os.environ["PYTHONPATH"] = os.environ["PYTHONPATH"] + ':$ANON_HOME_DIR/avalanche'
os.environ["PYTHONPATH"] = os.environ["PYTHONPATH"] + ':$ANON_HOME_DIR/dac_project'
sys.path.append("$ANON_HOME_DIR/dac_project")
sys.path.append("$ANON_HOME_DIR/avalanche")

import hydra

import copy
import os

from omegaconf import DictConfig, OmegaConf
from dac.training.configs.train_kd_latent import train_config as train_config_kd_latent

global train_config_foo

pil_logger = logging.getLogger('PIL')
pil_logger.setLevel(logging.INFO)


@hydra.main(config_path='../CONFIGS', config_name='base.yaml', version_base="1.2")
def main(base_config: DictConfig):
    if base_config.debug_mode:
        pass

    maybe_set_gpus(1)
    global train_config_foo

    train_config_foo = train_config_kd_latent

    ood_datas = [
        # "ameyoko",  # DONE
        # "animals",
        # "bridge",
        # "hubble",
        "imagenet_no_transform",
        # "noise"  # DONE
    ]

    basedir = os.getcwd()
    for ood_data in ood_datas:
        local_config = copy.deepcopy(base_config)

        # local_config = hydra.compose(overrides=f"ood_data={ood_data}")
        with open(f"{local_config.server.sourcedir}/CONFIGS/ood_data/{ood_data}.yaml") as f:
            local_config.ood_data = OmegaConf.load(f)
        sdate = datetime.datetime.now().strftime("%Y-%m-%d_%H-%M-%S")
        exp_name = basedir + '/' + ood_data + '/assess_' + sdate
        for runid in range(5):
            run_dir = exp_name + '/run' + str(runid)
            os.makedirs(run_dir, exist_ok=local_config.debug_mode)

            local_config.run_id = runid
            train_config_foo(local_config, base_dir=run_dir)


if __name__ == "__main__":
    main()
